import {
  __async,
  __spreadProps,
  __spreadValues
} from "./chunk-CRTRMMJ7.js";

// src/components/embed/v3/crypto/utils/handleSendTransaction.ts
function handleSendTransaction(primaryWallet, chain, serializedTransaction, iframeClient) {
  return __async(this, null, function* () {
    const commonParams = {
      chain,
      serializedTransaction,
      iframeClient
    };
    const { isSolanaWallet } = yield import("@dynamic-labs/solana");
    if (isSolanaWallet(primaryWallet)) {
      const { handleSolanaTransaction } = yield import("./components/embed/v3/crypto/utils/handleSolanaTransaction.js");
      return yield handleSolanaTransaction(__spreadProps(__spreadValues({}, commonParams), {
        primaryWallet
      }));
    }
    const { isEthereumWallet } = yield import("@dynamic-labs/ethereum");
    if (isEthereumWallet(primaryWallet)) {
      const { handleEvmTransaction } = yield import("./components/embed/v3/crypto/utils/handleEvmTransaction.js");
      return yield handleEvmTransaction(__spreadProps(__spreadValues({}, commonParams), { primaryWallet }));
    }
  });
}

export {
  handleSendTransaction
};
//# sourceMappingURL=chunk-HYGCZCR2.js.map